package ink.wgink.util.remote.rest.proxy;

import ink.wgink.util.remote.rest.handler.RestRemoteHandler;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestParam;

import java.lang.reflect.Proxy;

/**
 * @ClassName: RestRemoteProxy
 * @Description: Rest远程调用代理
 * @Author: wanggeng
 * @Date: 2021/9/18 5:40 下午
 * @Version: 1.0
 */
public class RestRemoteProxy {

    public static <T> T getInstance(Class<T> cls) {
        RestRemoteHandler restRemoteHandler = new RestRemoteHandler();
        Object o = Proxy.newProxyInstance(cls.getClassLoader(), new Class[]{cls}, restRemoteHandler);
        return (T) o;
    }

    public interface IDemo {
        @GetMapping("/demo/{p2}/{p1}")
        String test(@PathVariable("p1") String p1, @PathVariable("p2") String p2, @RequestParam("q1") String q1, @RequestParam("q2") String q2, @RequestHeader("access_token") String token, @RequestHeader("auth") String auth);
    }

    public static void main(String[] args) {
        IDemo instance = RestRemoteProxy.getInstance(IDemo.class);
        instance.test("pp1", "我是", null, "中国人", "token123456", null);
    }

}
